//------------------------------------------------------------------------------
// fBAtB^ی
//------------------------------------------------------------------------------
/*
gcc 4.6.1ŃRpCmF
*/
#include <windows.h>
#include <mmintrin.h>
#include <xmmintrin.h>
#include <emmintrin.h>
#include "filter.h"

//---------------------------------------------------------------------
// tB^\̒`
//---------------------------------------------------------------------
#define TRACK_N 2
TCHAR *track_name[]   = { (TCHAR*)"MSE", (TCHAR*)"" };
int     track_default[] = {  108,  1 };
int     track_s[]       = {    0,  1 };
int     track_e[]       = { 4096,  8 };

#define CHECK_N 1
TCHAR *check_name[] = { (TCHAR*)"r5_1_(荂)" };
int check_default[] = { 0 };

FILTER_DLL filter = {
    FILTER_FLAG_EX_INFORMATION,
    0,0,
    "fBAtB^ی",
    TRACK_N,
    track_name,
    track_default,
    track_s,track_e,
    CHECK_N,
    check_name,
    check_default,
    func_proc,
    func_init,
    NULL,
    NULL,
    NULL,
    NULL,NULL,
    NULL,
    0,
    "fBAtB^ی ver 0.1.0 by ۂ",
    NULL,
    NULL,
};

//---------------------------------------------------------------------
// ϐFX
//---------------------------------------------------------------------

// Xbhɓn\
typedef struct {
    int MSE;
    int separate_start;
    int separate_end;
} THREAD_PARAM;

//---------------------------------------------------------------------
// SIMD̃tO
//---------------------------------------------------------------------
#define FLAG_MMX  0x800000
#define FLAG_SSE  0x2000000
#define FLAG_SSE2 0x4000000

__declspec(noinline) int cpuid_simd()
{
    int flag;
    __asm volatile (
        "movl $1,%%eax   \n"
        "cpuid           \n"
        "movl %%edx,%0   \n"
        : "=m" (flag)
        :
        : "%eax", "%ebx", "%ecx", "%edx" // 4ޔȂƃoO
    );
    return flag; 
}

//---------------------------------------------------------------------
// tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
    return &filter;
}

//---------------------------------------------------------------------
// 
//---------------------------------------------------------------------
BOOL func_init( FILTER *fp )
{
    // SSE2̑Ή`FbN
    if( !(cpuid_simd() & FLAG_SSE2) ) return FALSE;
    return TRUE;
}

//---------------------------------------------------------------------
// short^232bitɂ
//---------------------------------------------------------------------
#define MK_INT( A, B ) ( (int)(unsigned short)A | ((int)B << 16) )

//---------------------------------------------------------------------
// rēւ
//---------------------------------------------------------------------
#define MIN_MAX_SSE2( A, B ) \
    { \
        const __m128i max = _mm_max_epi16( A, B ); \
        const __m128i min = _mm_min_epi16( B, A ); \
        A = min; \
        B = max; \
    }

//---------------------------------------------------------------------
// l
//---------------------------------------------------------------------
// 5vf
#define FIND_MEDIUM_FIVE( M0, M1, M2, M3, M4 ) \
    { \
        MIN_MAX_SSE2( M0, M1 ); \
        MIN_MAX_SSE2( M3, M4 ); \
        MIN_MAX_SSE2( M0, M3 ); \
        MIN_MAX_SSE2( M1, M4 ); \
        MIN_MAX_SSE2( M2, M3 ); \
        MIN_MAX_SSE2( M1, M2 ); \
        MIN_MAX_SSE2( M2, M3 ); \
    }

// 9vfB
// x86łxmmWX^Ȃ̂łł͗]vȃXgA[hĂ܂B
// KɃ[h邱ƂŃXgA[h炷KvB
#define FIND_MEDIUM_NINE( M0, M1, M2, M3, M4, M5, M6, M7, M8 ) \
    { \
        MIN_MAX_SSE2( M0, M1 ); \
        MIN_MAX_SSE2( M1, M2 ); \
        MIN_MAX_SSE2( M0, M1 ); \
        MIN_MAX_SSE2( M3, M4 ); \
        MIN_MAX_SSE2( M4, M5 ); \
        MIN_MAX_SSE2( M3, M4 ); \
        MIN_MAX_SSE2( M0, M3 ); \
        MIN_MAX_SSE2( M2, M5 ); \
        MIN_MAX_SSE2( M1, M4 ); \
        MIN_MAX_SSE2( M6, M7 ); \
        MIN_MAX_SSE2( M7, M8 ); \
        MIN_MAX_SSE2( M6, M7 ); \
        MIN_MAX_SSE2( M3, M6 ); \
        MIN_MAX_SSE2( M2, M8 ); \
        MIN_MAX_SSE2( M4, M7 ); \
        MIN_MAX_SSE2( M1, M4 ); \
        MIN_MAX_SSE2( M2, M4 ); \
        MIN_MAX_SSE2( M4, M6 ); \
        MIN_MAX_SSE2( M2, M4 ); \
    }

//---------------------------------------------------------------------
// fBAtB^p[g
//
// 3x3̃fBAtB^s
// 摜Ƃ̍쐬
//---------------------------------------------------------------------
void __attribute__((force_align_arg_pointer)) thread_median( int thread_id, int thread_num, void *param1, void *param2 )
{
    const THREAD_PARAM *tp = (THREAD_PARAM *)param1;
    const FILTER_PROC_INFO *fpip = (FILTER_PROC_INFO *)param2;

    // Rs[
    int w              = fpip->w;
    int h              = fpip->h;
    int max_w          = fpip->max_w;
    int separate_start = tp->separate_start;
    int separate_end   = tp->separate_end;

    // sȒl͒e
    if( h <= 0 || w <= 0 || max_w <= 0 || thread_num <= 0 || separate_end < separate_start ) return;

    // Xbhc̃TCY葽璲
    int separate_h = separate_end - separate_start;
    if( thread_num > separate_h ) thread_num = separate_h;
    if( thread_id >= thread_num || thread_id < 0 ) return;

    // Xbh̉摜郉CvZ
    const int y_start = (separate_h *  thread_id     ) / thread_num + separate_start;
    const int y_end   = (separate_h * (thread_id + 1)) / thread_num + separate_start;

    // short^Pʂł̂3{
    w     *= 3;
    max_w *= 3;

    int x_end = w - 3;

    // |C^ishort^Ɂj
    const short *__restrict__ src = (short *)fpip->ycp_edit;
          short *__restrict__ dst = (short *)fpip->ycp_temp;

    for( int y = y_start; y < y_end; y++ )
    {
        // [0
        if( y < 0 || y >= h )
        {
            int n = 0;
            for( ; n < w - 7; n += 8 )
            {
                _mm_stream_si128( (__m128i *)&dst[y*max_w + n], _mm_setzero_si128() );
            }
            for( ; n < w; n++ )
            {
                dst[y*max_w + n] = 0;
            }
            continue;
        }

        // AviUtl͊eC16bytẽACgɑĂ炵
        // ̂Ƃ͖mɐ͂ĂȂ
        // ȉ͑Ă邱ƂOɏĂ܂

        // [8
        // 1sNZ(3)͏Ȃ̂ŌʓI0ɂȂ悤ɂ
        {
            __m128i m1 = _mm_load_si128( (__m128i *)&src[(y-1)*max_w  ] );
            __m128i m2 = _mm_loadu_si128( (__m128i *)&src[(y-1)*max_w+3] );
            __m128i m0 = _mm_slli_si128( m1, 6 );
            MIN_MAX_SSE2( m0, m1 );
            MIN_MAX_SSE2( m1, m2 );
            MIN_MAX_SSE2( m0, m1 );
            __m128i m4 = _mm_load_si128( (__m128i *)&src[y*max_w  ] );
            __m128i m5 = _mm_loadu_si128( (__m128i *)&src[y*max_w+3] );
            __m128i m3 = _mm_slli_si128( m4, 6 );
            __m128i ce = m4;
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m4, m5 );
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m0, m3 );
            MIN_MAX_SSE2( m2, m5 );
            MIN_MAX_SSE2( m1, m4 );
            __m128i m7 = _mm_load_si128( (__m128i *)&src[(y+1)*max_w  ] );
            __m128i m8 = _mm_loadu_si128( (__m128i *)&src[(y+1)*max_w+3] );
            __m128i m6 = _mm_slli_si128( m7, 6 );
            _mm_prefetch( &src[(y+2)*max_w], _MM_HINT_T1  ); // ̃CvtFb`
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m7, m8 );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m3, m6 );
            MIN_MAX_SSE2( m2, m8 );
            MIN_MAX_SSE2( m4, m7 );
            MIN_MAX_SSE2( m1, m4 );
            MIN_MAX_SSE2( m2, m4 );
            MIN_MAX_SSE2( m4, m6 );
            MIN_MAX_SSE2( m2, m4 );
            // 6oCg0ɂȂ悤ɃVtg
            __m128i p = _mm_slli_si128( _mm_srli_si128( m4, 6 ), 6 );
            _mm_stream_si128( (__m128i *)&dst[y*max_w], _mm_subs_epi16( ce, p ) );
        }

        int x = 8;

        // 8
        for( ; x < x_end - 7; x += 8 )
        {
            __m128i m0 = _mm_loadu_si128( (__m128i *)&src[(y-1)*max_w+x-3] );
            __m128i m1 = _mm_load_si128( (__m128i *)&src[(y-1)*max_w+x  ] );
            __m128i m2 = _mm_loadu_si128( (__m128i *)&src[(y-1)*max_w+x+3] );
            MIN_MAX_SSE2( m0, m1 );
            MIN_MAX_SSE2( m1, m2 );
            MIN_MAX_SSE2( m0, m1 );
            __m128i m3 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x-3] );
            __m128i m4 = _mm_load_si128( (__m128i *)&src[y*max_w+x  ] );
            __m128i m5 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x+3] );
            __m128i ce = m4;
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m4, m5 );
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m0, m3 );
            MIN_MAX_SSE2( m2, m5 );
            MIN_MAX_SSE2( m1, m4 );
            __m128i m6 = _mm_loadu_si128( (__m128i *)&src[(y+1)*max_w+x-3] );
            __m128i m7 = _mm_load_si128( (__m128i *)&src[(y+1)*max_w+x  ] );
            __m128i m8 = _mm_loadu_si128( (__m128i *)&src[(y+1)*max_w+x+3] );
            _mm_prefetch( &src[(y+2)*max_w+x], _MM_HINT_T1  ); // ̃CvtFb`
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m7, m8 );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m3, m6 );
            MIN_MAX_SSE2( m2, m8 );
            MIN_MAX_SSE2( m4, m7 );
            MIN_MAX_SSE2( m1, m4 );
            MIN_MAX_SSE2( m2, m4 );
            MIN_MAX_SSE2( m4, m6 );
            MIN_MAX_SSE2( m2, m4 );
            _mm_stream_si128( (__m128i *)&dst[y*max_w+x], _mm_subs_epi16( ce, m4 ) );
        }

        // [4
        if( x < x_end - 3 )
        {
            __m128i m0 = _mm_loadl_epi64( (__m128i *)&src[(y-1)*max_w+x-3] );
            __m128i m1 = _mm_loadl_epi64( (__m128i *)&src[(y-1)*max_w+x  ] );
            __m128i m2 = _mm_loadl_epi64( (__m128i *)&src[(y-1)*max_w+x+3] );
            MIN_MAX_SSE2( m0, m1 );
            MIN_MAX_SSE2( m1, m2 );
            MIN_MAX_SSE2( m0, m1 );
            __m128i m3 = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x-3] );
            __m128i m4 = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x  ] );
            __m128i m5 = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x+3] );
            __m128i ce = m4;
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m4, m5 );
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m0, m3 );
            MIN_MAX_SSE2( m2, m5 );
            MIN_MAX_SSE2( m1, m4 );
            __m128i m6 = _mm_loadl_epi64( (__m128i *)&src[(y+1)*max_w+x-3] );
            __m128i m7 = _mm_loadl_epi64( (__m128i *)&src[(y+1)*max_w+x  ] );
            __m128i m8 = _mm_loadl_epi64( (__m128i *)&src[(y+1)*max_w+x+3] );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m7, m8 );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m3, m6 );
            MIN_MAX_SSE2( m2, m8 );
            MIN_MAX_SSE2( m4, m7 );
            MIN_MAX_SSE2( m1, m4 );
            MIN_MAX_SSE2( m2, m4 );
            MIN_MAX_SSE2( m4, m6 );
            MIN_MAX_SSE2( m2, m4 );
            __m128i p = _mm_subs_epi16( ce, m4 );
            _mm_stream_si32( (int *)&dst[y*max_w+x  ], _mm_cvtsi128_si32( p ) );
            _mm_stream_si32( (int *)&dst[y*max_w+x+2], _mm_cvtsi128_si32( _mm_srli_si128( p, 4 ) ) );
            x += 4;
        }
        // [2
        if( x < x_end - 1 )
        {
            __m128i m0 = _mm_cvtsi32_si128( *(int *)&src[(y-1)*max_w+x-3] );
            __m128i m1 = _mm_cvtsi32_si128( *(int *)&src[(y-1)*max_w+x  ] );
            __m128i m2 = _mm_cvtsi32_si128( *(int *)&src[(y-1)*max_w+x+3] );
            MIN_MAX_SSE2( m0, m1 );
            MIN_MAX_SSE2( m1, m2 );
            MIN_MAX_SSE2( m0, m1 );
            __m128i m3 = _mm_cvtsi32_si128( *(int *)&src[y*max_w+x-3] );
            __m128i m4 = _mm_cvtsi32_si128( *(int *)&src[y*max_w+x  ] );
            __m128i m5 = _mm_cvtsi32_si128( *(int *)&src[y*max_w+x+3] );
            __m128i ce = m4;
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m4, m5 );
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m0, m3 );
            MIN_MAX_SSE2( m2, m5 );
            MIN_MAX_SSE2( m1, m4 );
            __m128i m6 = _mm_cvtsi32_si128( *(int *)&src[(y+1)*max_w+x-3] );
            __m128i m7 = _mm_cvtsi32_si128( *(int *)&src[(y+1)*max_w+x  ] );
            __m128i m8 = _mm_cvtsi32_si128( *(int *)&src[(y+1)*max_w+x+3] );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m7, m8 );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m3, m6 );
            MIN_MAX_SSE2( m2, m8 );
            MIN_MAX_SSE2( m4, m7 );
            MIN_MAX_SSE2( m1, m4 );
            MIN_MAX_SSE2( m2, m4 );
            MIN_MAX_SSE2( m4, m6 );
            MIN_MAX_SSE2( m2, m4 );
            __m128i p = _mm_subs_epi16( ce, m4 );
            _mm_stream_si32( (int *)&dst[y*max_w+x  ], _mm_cvtsi128_si32( p ) );
            x += 2;
        }
        // [1
        if( x < x_end )
        {
            __m128i m0 = _mm_cvtsi32_si128( src[(y-1)*max_w+x-3] );
            __m128i m1 = _mm_cvtsi32_si128( src[(y-1)*max_w+x  ] );
            __m128i m2 = _mm_cvtsi32_si128( src[(y-1)*max_w+x+3] );
            MIN_MAX_SSE2( m0, m1 );
            MIN_MAX_SSE2( m1, m2 );
            MIN_MAX_SSE2( m0, m1 );
            __m128i m3 = _mm_cvtsi32_si128( src[y*max_w+x-3] );
            __m128i m4 = _mm_cvtsi32_si128( src[y*max_w+x  ] );
            __m128i m5 = _mm_cvtsi32_si128( src[y*max_w+x+3] );
            __m128i ce = m4;
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m4, m5 );
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m0, m3 );
            MIN_MAX_SSE2( m2, m5 );
            MIN_MAX_SSE2( m1, m4 );
            __m128i m6 = _mm_cvtsi32_si128( src[(y+1)*max_w+x-3] );
            __m128i m7 = _mm_cvtsi32_si128( src[(y+1)*max_w+x  ] );
            __m128i m8 = _mm_cvtsi32_si128( src[(y+1)*max_w+x+3] );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m7, m8 );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m3, m6 );
            MIN_MAX_SSE2( m2, m8 );
            MIN_MAX_SSE2( m4, m7 );
            MIN_MAX_SSE2( m1, m4 );
            MIN_MAX_SSE2( m2, m4 );
            MIN_MAX_SSE2( m4, m6 );
            MIN_MAX_SSE2( m2, m4 );
            __m128i p = _mm_subs_epi16( ce, m4 );
            p = _mm_insert_epi16( p, 0, 1 );
            _mm_stream_si32( (int *)&dst[y*max_w+x  ], _mm_cvtsi128_si32( p ) );
            _mm_stream_si32( (int *)&dst[y*max_w+x+2], 0 );
        }
        else
        {
            // E[0Ŗ߂
            for( ; x < w; x++ ) dst[y*max_w+x] = 0;
        }
    }
}

//---------------------------------------------------------------------
// p[g
//
// 摜ɑ΂4ߖT+Sŕϓ덷ƂUƌ̂vZ
// 臒lȏȂ炻̓_O
// 摜ɔf
//---------------------------------------------------------------------
void __attribute__((force_align_arg_pointer)) thread_diff( int thread_id, int thread_num, void *param1, void *param2 )
{
    const THREAD_PARAM *tp = (THREAD_PARAM *)param1;
    const FILTER_PROC_INFO *fpip = (FILTER_PROC_INFO *)param2;

    // Rs[
    int w              = fpip->w;
    int h              = fpip->h;
    int max_w          = fpip->max_w;
    int separate_start = tp->separate_start;
    int separate_end   = tp->separate_end;

    // sȒl͒e
    if( h <= 0 || w <= 0 || max_w <= 0 || thread_num <= 0 || separate_end < separate_start ) return;

    // Xbhc̃TCY葽璲
    int separate_h = separate_end - separate_start;
    if( thread_num > separate_h ) thread_num = separate_h;
    if( thread_id >= thread_num || thread_id < 0 ) return;

    // Xbh̉摜郉CvZ
    const int y_start = (separate_h *  thread_id     ) / thread_num + separate_start;
    const int y_end   = (separate_h * (thread_id + 1)) / thread_num + separate_start;

    // short^Pʂł̂3{
    w       *= 3;
    max_w   *= 3;

    int x_end = w - 3;

    // |C^ishort^Ɂj
    const short *__restrict__ src = (short *)fpip->ycp_temp;
          short *__restrict__ dst = (short *)fpip->ycp_edit;

    // MSErp
    const __m128i threshold128 = _mm_set1_epi32( tp->MSE * tp->MSE * 5 );

    for( int y = y_start; y < y_end; y++ )
    {
        // [͉Ȃ
        if( y < 0 || y >= h ) continue;


        // AviUtl͊eC16bytẽACgɑĂ炵
        // ̂Ƃ͖mɐ͂ĂȂ
        // ȉ͑Ă邱ƂOɏĂ܂

        // [8
        // 1sNZ(3)͏Ȃ̂ŌʓI0ɂȂ悤ɂ
        {
            __m128i sum0, sum1, lo, hi, p0, p1, center, mask;

            // Ɖ
            p0 = _mm_load_si128( (__m128i *)&src[(y-1)*max_w] );
            p1 = _mm_load_si128( (__m128i *)&src[(y+1)*max_w] );
            lo = _mm_unpacklo_epi16( p0, p1 );
            hi = _mm_unpackhi_epi16( p0, p1 );
            sum0 = _mm_madd_epi16( lo, lo );
            sum1 = _mm_madd_epi16( hi, hi );

            // ƉEiACgĂȂ̂loaduj
            p0 = _mm_loadu_si128( (__m128i *)&src[y*max_w-3] );
            center = _mm_load_si128( (__m128i *)&src[y*max_w] );
            p1 = _mm_slli_si128( center, 6 );
            lo = _mm_unpacklo_epi16( p0, p1 );
            hi = _mm_unpackhi_epi16( p0, p1 );
            sum0 = _mm_add_epi32( sum0, _mm_madd_epi16( lo, lo ) );
            sum1 = _mm_add_epi32( sum1, _mm_madd_epi16( hi, hi ) );

            // S
            lo = _mm_mullo_epi16( center, center );
            hi = _mm_mulhi_epi16( center, center );
            sum0 = _mm_add_epi32( sum0, _mm_unpacklo_epi16( lo, hi ) );
            sum1 = _mm_add_epi32( sum1, _mm_unpackhi_epi16( lo, hi ) );

            // }XN쐬
            mask = _mm_packs_epi32( _mm_cmplt_epi32( sum0, threshold128 ), _mm_cmplt_epi32( sum1, threshold128 ) );

            _mm_prefetch( &src[(y+2)*max_w], _MM_HINT_T1 ); // ̃CvtFb`
            _mm_prefetch( &dst[(y+1)*max_w], _MM_HINT_T1 ); // ̃CvtFb`

            p0 = _mm_load_si128( (__m128i *)&dst[y*max_w] );
            p0 = _mm_subs_epi16( p0, _mm_and_si128( center, mask ) );
            _mm_store_si128( (__m128i *)&dst[y*max_w], p0 );
        }

        int x = 8;

        // 8
        for( ; x < x_end - 7; x += 8 )
        {
            __m128i sum0, sum1, lo, hi, p0, p1, center, mask;

            // ㉺ESꂼ悵čvĂ

            // Ɖ
            p0 = _mm_load_si128( (__m128i *)&src[(y-1)*max_w+x] );
            p1 = _mm_load_si128( (__m128i *)&src[(y+1)*max_w+x] );
            lo = _mm_unpacklo_epi16( p0, p1 );
            hi = _mm_unpackhi_epi16( p0, p1 );
            sum0 = _mm_madd_epi16( lo, lo );
            sum1 = _mm_madd_epi16( hi, hi );

            // ƉEiACgĂȂ̂loaduj
            p0 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x-3] );
            p1 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x+3] );
            lo = _mm_unpacklo_epi16( p0, p1 );
            hi = _mm_unpackhi_epi16( p0, p1 );
            sum0 = _mm_add_epi32( sum0, _mm_madd_epi16( lo, lo ) );
            sum1 = _mm_add_epi32( sum1, _mm_madd_epi16( hi, hi ) );

            // S
            center = _mm_load_si128( (__m128i *)&src[y*max_w+x] );
            lo = _mm_mullo_epi16( center, center );
            hi = _mm_mulhi_epi16( center, center );
            sum0 = _mm_add_epi32( sum0, _mm_unpacklo_epi16( lo, hi ) );
            sum1 = _mm_add_epi32( sum1, _mm_unpackhi_epi16( lo, hi ) );

            // }XN쐬
            mask = _mm_packs_epi32( _mm_cmplt_epi32( sum0, threshold128 ), _mm_cmplt_epi32( sum1, threshold128 ) );

            _mm_prefetch( &src[(y+2)*max_w+x], _MM_HINT_T1 ); // ̃CvtFb`
            _mm_prefetch( &dst[(y+1)*max_w+x], _MM_HINT_T1 ); // ̃CvtFb`

            p0 = _mm_load_si128( (__m128i *)&dst[y*max_w+x] );
            p0 = _mm_subs_epi16( p0, _mm_and_si128( center, mask ) );
            _mm_store_si128( (__m128i *)&dst[y*max_w+x], p0 );
            //_mm_store_si128( (__m128i *)&dst[y*max_w+x], _mm_and_si128( center, mask ) );
        }

        // [4
        if( x < x_end - 3 )
        {
            __m128i sum0, lo, p0, p1, center, mask;

            // Ɖ
            p0 = _mm_loadl_epi64( (__m128i *)&src[(y-1)*max_w+x] );
            p1 = _mm_loadl_epi64( (__m128i *)&src[(y+1)*max_w+x] );
            lo = _mm_unpacklo_epi16( p0, p1 );
            sum0 = _mm_madd_epi16( lo, lo );

            // ƉEiACgĂȂ̂loaduj
            p0 = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x-3] );
            p1 = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x+3] );
            lo = _mm_unpacklo_epi16( p0, p1 );
            sum0 = _mm_add_epi32( sum0, _mm_madd_epi16( lo, lo ) );

            // S
            center = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x] );
            lo = _mm_unpacklo_epi16( center, _mm_setzero_si128() );
            sum0 = _mm_add_epi32( sum0, _mm_madd_epi16( lo, lo ) );

            // }XN쐬
            mask = _mm_packs_epi32( _mm_cmplt_epi32( sum0, threshold128 ), _mm_setzero_si128() );

            p0 = _mm_loadl_epi64( (__m128i *)&dst[y*max_w+x] );
            p0 = _mm_subs_epi16( p0, _mm_and_si128( center, mask ) );
            _mm_storel_epi64( (__m128i *)&dst[y*max_w+x], p0 );

            x += 4;
        }
        // [2
        if( x < x_end - 1 )
        {
            __m128i sum0, lo, p0, p1, center, mask;

            // Ɖ
            p0 = _mm_loadl_epi64( (__m128i *)&src[(y-1)*max_w+x] );
            p1 = _mm_loadl_epi64( (__m128i *)&src[(y+1)*max_w+x] );
            lo = _mm_unpacklo_epi16( p0, p1 );
            sum0 = _mm_madd_epi16( lo, lo );

            // ƉEiACgĂȂ̂loaduj
            p0 = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x-3] );
            p1 = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x+3] );
            lo = _mm_unpacklo_epi16( p0, p1 );
            sum0 = _mm_add_epi32( sum0, _mm_madd_epi16( lo, lo ) );

            // S
            center = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x] );
            lo = _mm_unpacklo_epi16( center, _mm_setzero_si128() );
            sum0 = _mm_add_epi32( sum0, _mm_madd_epi16( lo, lo ) );

            // }XN쐬
            mask = _mm_packs_epi32( _mm_cmplt_epi32( sum0, threshold128 ), _mm_setzero_si128() );

            p0 = _mm_cvtsi32_si128( *(int *)&dst[y*max_w+x] );
            p0 = _mm_subs_epi16( p0, _mm_and_si128( center, mask ) );
            dst[y*max_w+x+0] = _mm_extract_epi16( p0, 0 );
            dst[y*max_w+x+1] = _mm_extract_epi16( p0, 1 );
            x += 2;
        }
        // [1
        if( x < x_end )
        {
            __m128i sum0, lo, p0, p1, center, mask;

            // Ɖ
            p0 = _mm_loadl_epi64( (__m128i *)&src[(y-1)*max_w+x] );
            p1 = _mm_loadl_epi64( (__m128i *)&src[(y+1)*max_w+x] );
            lo = _mm_unpacklo_epi16( p0, p1 );
            sum0 = _mm_madd_epi16( lo, lo );

            // ƉEiACgĂȂ̂loaduj
            p0 = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x-3] );
            p1 = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x+3] );
            lo = _mm_unpacklo_epi16( p0, p1 );
            sum0 = _mm_add_epi32( sum0, _mm_madd_epi16( lo, lo ) );

            // S
            center = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x] );
            lo = _mm_unpacklo_epi16( center, _mm_setzero_si128() );
            sum0 = _mm_add_epi32( sum0, _mm_madd_epi16( lo, lo ) );

            // }XN쐬
            mask = _mm_packs_epi32( _mm_cmplt_epi32( sum0, threshold128 ),  _mm_setzero_si128() );

            p0 = _mm_cvtsi32_si128( *(int *)&dst[y*max_w+x+0] );
            p0 = _mm_subs_epi16( p0, _mm_and_si128( center, mask ) );
            dst[y*max_w+x+0] = _mm_extract_epi16( p0, 0 );
            x++;
        }

    }
}

//---------------------------------------------------------------------
// fBAtB^ƍꏏɂ
// A5_1_
//---------------------------------------------------------------------
void __attribute__((force_align_arg_pointer)) thread_median_diff( int thread_id, int thread_num, void *param1, void *param2 )
{
    const THREAD_PARAM *tp = (THREAD_PARAM *)param1;
    const FILTER_PROC_INFO *fpip = (FILTER_PROC_INFO *)param2;

    // Rs[
    int w              = fpip->w;
    int h              = fpip->h;
    int max_w          = fpip->max_w;

    // sȒl͒e
    if( h <= 0 || w <= 0 || max_w <= 0 || thread_num <= 0 ) return;

    // Xbhc̃TCY葽璲
    if( thread_num > h ) thread_num = h;
    if( thread_id >= thread_num || thread_id < 0 ) return;

    // Xbh̉摜郉CvZ
    const int y_start = (h *  thread_id     ) / thread_num;
    const int y_end   = (h * (thread_id + 1)) / thread_num;

    // short^Pʂł̂3{
    w     *= 3;
    max_w *= 3;

    int x_end = w - 3;

    // |C^ishort^Ɂj
    const short *__restrict__ src = (short *)fpip->ycp_edit;
          short *__restrict__ dst = (short *)fpip->ycp_temp;

    // MSErp
    const __m128i threshold128_p = _mm_set1_epi16( tp->MSE );      // vX
    const __m128i threshold128_m = _mm_set1_epi16( tp->MSE * -1 ); // }CiX

    for( int y = y_start; y < y_end; y++ )
    {
        // [͂̂܂܃Rs[
        if( y < 0 || y >= h )
        {
            // gp̈gāARs[vfł邾8̔{ɂ
            int num = w;
            int t = (w + 7) & ~0x7;
            if( num < max_w ) num = t;

            int n = 0;
            for( ; n < num - 7; n += 8 )
            {
                __m128i p = _mm_load_si128( (__m128i *)&src[y*max_w + n] );
                _mm_stream_si128( (__m128i *)&dst[y*max_w + n], p );
            }
            for( ; n < num; n++ )
            {
                dst[y*max_w + n] = src[y*max_w + n];
            }
            continue;
        }

        // AviUtl͊eC16bytẽACgɑĂ炵
        // ̂Ƃ͖mɐ͂ĂȂ
        // ȉ͑Ă邱ƂOɏĂ܂

        // [8
        // 1sNZ(3)͏Ȃ̂ŌʓI0ɂȂ悤ɂ
        {
            __m128i m1 = _mm_load_si128( (__m128i *)&src[(y-1)*max_w  ] );
            __m128i m2 = _mm_loadu_si128( (__m128i *)&src[(y-1)*max_w+3] );
            __m128i m0 = _mm_slli_si128( m1, 6 );
            MIN_MAX_SSE2( m0, m1 );
            MIN_MAX_SSE2( m1, m2 );
            MIN_MAX_SSE2( m0, m1 );
            __m128i m4 = _mm_load_si128( (__m128i *)&src[y*max_w  ] );
            __m128i m5 = _mm_loadu_si128( (__m128i *)&src[y*max_w+3] );
            __m128i m3 = _mm_slli_si128( m4, 6 );
            __m128i ce = m4;
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m4, m5 );
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m0, m3 );
            MIN_MAX_SSE2( m2, m5 );
            MIN_MAX_SSE2( m1, m4 );
            __m128i m7 = _mm_load_si128( (__m128i *)&src[(y+1)*max_w  ] );
            __m128i m8 = _mm_loadu_si128( (__m128i *)&src[(y+1)*max_w+3] );
            __m128i m6 = _mm_slli_si128( m7, 6 );
            _mm_prefetch( &src[(y+2)*max_w], _MM_HINT_T1  ); // ̃CvtFb`
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m7, m8 );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m3, m6 );
            MIN_MAX_SSE2( m2, m8 );
            MIN_MAX_SSE2( m4, m7 );
            MIN_MAX_SSE2( m1, m4 );
            MIN_MAX_SSE2( m2, m4 );
            MIN_MAX_SSE2( m4, m6 );
            MIN_MAX_SSE2( m2, m4 ); // m4l

            __m128i p = _mm_slli_si128( _mm_srli_si128( m4, 6 ), 6 ); // 6oCg0ɂȂ悤ɃVtg
            __m128i diff = _mm_subs_epi16( ce, p ); // 
            __m128i mask = _mm_and_si128( _mm_cmplt_epi16( diff, threshold128_p ), _mm_cmpgt_epi16( diff, threshold128_m ) ); // }XN
            diff = _mm_and_si128( diff, mask ); // }XNKp
            p = _mm_subs_epi16( ce, diff ); // Kp
            _mm_stream_si128( (__m128i *)&dst[y*max_w], p );
        }

        int x = 8;

        // 8
        for( ; x < x_end - 7; x += 8 )
        {
            __m128i m0 = _mm_loadu_si128( (__m128i *)&src[(y-1)*max_w+x-3] );
            __m128i m1 = _mm_load_si128( (__m128i *)&src[(y-1)*max_w+x  ] );
            __m128i m2 = _mm_loadu_si128( (__m128i *)&src[(y-1)*max_w+x+3] );
            MIN_MAX_SSE2( m0, m1 );
            MIN_MAX_SSE2( m1, m2 );
            MIN_MAX_SSE2( m0, m1 );
            __m128i m3 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x-3] );
            __m128i m4 = _mm_load_si128( (__m128i *)&src[y*max_w+x  ] );
            __m128i m5 = _mm_loadu_si128( (__m128i *)&src[y*max_w+x+3] );
            __m128i ce = m4;
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m4, m5 );
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m0, m3 );
            MIN_MAX_SSE2( m2, m5 );
            MIN_MAX_SSE2( m1, m4 );
            __m128i m6 = _mm_loadu_si128( (__m128i *)&src[(y+1)*max_w+x-3] );
            __m128i m7 = _mm_load_si128( (__m128i *)&src[(y+1)*max_w+x  ] );
            __m128i m8 = _mm_loadu_si128( (__m128i *)&src[(y+1)*max_w+x+3] );
            _mm_prefetch( &src[(y+2)*max_w+x], _MM_HINT_T1  ); // ̃CvtFb`
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m7, m8 );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m3, m6 );
            MIN_MAX_SSE2( m2, m8 );
            MIN_MAX_SSE2( m4, m7 );
            MIN_MAX_SSE2( m1, m4 );
            MIN_MAX_SSE2( m2, m4 );
            MIN_MAX_SSE2( m4, m6 );
            MIN_MAX_SSE2( m2, m4 ); // m4l

            __m128i diff = _mm_subs_epi16( ce, m4 ); // 
            __m128i mask = _mm_and_si128( _mm_cmplt_epi16( diff, threshold128_p ), _mm_cmpgt_epi16( diff, threshold128_m ) ); // }XN
            diff = _mm_and_si128( diff, mask ); // }XNKp
            __m128i p = _mm_subs_epi16( ce, diff ); // Kp
            _mm_stream_si128( (__m128i *)&dst[y*max_w+x], p );
        }

        // [4
        if( x < x_end - 3 )
        {
            __m128i m0 = _mm_loadl_epi64( (__m128i *)&src[(y-1)*max_w+x-3] );
            __m128i m1 = _mm_loadl_epi64( (__m128i *)&src[(y-1)*max_w+x  ] );
            __m128i m2 = _mm_loadl_epi64( (__m128i *)&src[(y-1)*max_w+x+3] );
            MIN_MAX_SSE2( m0, m1 );
            MIN_MAX_SSE2( m1, m2 );
            MIN_MAX_SSE2( m0, m1 );
            __m128i m3 = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x-3] );
            __m128i m4 = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x  ] );
            __m128i m5 = _mm_loadl_epi64( (__m128i *)&src[y*max_w+x+3] );
            __m128i ce = m4;
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m4, m5 );
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m0, m3 );
            MIN_MAX_SSE2( m2, m5 );
            MIN_MAX_SSE2( m1, m4 );
            __m128i m6 = _mm_loadl_epi64( (__m128i *)&src[(y+1)*max_w+x-3] );
            __m128i m7 = _mm_loadl_epi64( (__m128i *)&src[(y+1)*max_w+x  ] );
            __m128i m8 = _mm_loadl_epi64( (__m128i *)&src[(y+1)*max_w+x+3] );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m7, m8 );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m3, m6 );
            MIN_MAX_SSE2( m2, m8 );
            MIN_MAX_SSE2( m4, m7 );
            MIN_MAX_SSE2( m1, m4 );
            MIN_MAX_SSE2( m2, m4 );
            MIN_MAX_SSE2( m4, m6 );
            MIN_MAX_SSE2( m2, m4 );

            __m128i diff = _mm_subs_epi16( ce, m4 ); // 
            __m128i mask = _mm_and_si128( _mm_cmplt_epi16( diff, threshold128_p ), _mm_cmpgt_epi16( diff, threshold128_m ) ); // }XN
            diff = _mm_and_si128( diff, mask ); // }XNKp
            __m128i p = _mm_subs_epi16( ce, diff ); // Kp
            _mm_stream_si32( (int *)&dst[y*max_w+x  ], _mm_cvtsi128_si32( p ) );
            _mm_stream_si32( (int *)&dst[y*max_w+x+2], _mm_cvtsi128_si32( _mm_srli_si128( p, 4 ) ) );
            x += 4;
        }
        // [2
        if( x < x_end - 1 )
        {
            __m128i m0 = _mm_cvtsi32_si128( *(int *)&src[(y-1)*max_w+x-3] );
            __m128i m1 = _mm_cvtsi32_si128( *(int *)&src[(y-1)*max_w+x  ] );
            __m128i m2 = _mm_cvtsi32_si128( *(int *)&src[(y-1)*max_w+x+3] );
            MIN_MAX_SSE2( m0, m1 );
            MIN_MAX_SSE2( m1, m2 );
            MIN_MAX_SSE2( m0, m1 );
            __m128i m3 = _mm_cvtsi32_si128( *(int *)&src[y*max_w+x-3] );
            __m128i m4 = _mm_cvtsi32_si128( *(int *)&src[y*max_w+x  ] );
            __m128i m5 = _mm_cvtsi32_si128( *(int *)&src[y*max_w+x+3] );
            __m128i ce = m4;
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m4, m5 );
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m0, m3 );
            MIN_MAX_SSE2( m2, m5 );
            MIN_MAX_SSE2( m1, m4 );
            __m128i m6 = _mm_cvtsi32_si128( *(int *)&src[(y+1)*max_w+x-3] );
            __m128i m7 = _mm_cvtsi32_si128( *(int *)&src[(y+1)*max_w+x  ] );
            __m128i m8 = _mm_cvtsi32_si128( *(int *)&src[(y+1)*max_w+x+3] );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m7, m8 );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m3, m6 );
            MIN_MAX_SSE2( m2, m8 );
            MIN_MAX_SSE2( m4, m7 );
            MIN_MAX_SSE2( m1, m4 );
            MIN_MAX_SSE2( m2, m4 );
            MIN_MAX_SSE2( m4, m6 );
            MIN_MAX_SSE2( m2, m4 );

            __m128i diff = _mm_subs_epi16( ce, m4 ); // 
            __m128i mask = _mm_and_si128( _mm_cmplt_epi16( diff, threshold128_p ), _mm_cmpgt_epi16( diff, threshold128_m ) ); // }XN
            diff = _mm_and_si128( diff, mask ); // }XNKp
            __m128i p = _mm_subs_epi16( ce, diff ); // Kp
            _mm_stream_si32( (int *)&dst[y*max_w+x  ], _mm_cvtsi128_si32( p ) );
            x += 2;
        }
        // [1
        if( x < x_end )
        {
            __m128i m0 = _mm_cvtsi32_si128( src[(y-1)*max_w+x-3] );
            __m128i m1 = _mm_cvtsi32_si128( src[(y-1)*max_w+x  ] );
            __m128i m2 = _mm_cvtsi32_si128( src[(y-1)*max_w+x+3] );
            MIN_MAX_SSE2( m0, m1 );
            MIN_MAX_SSE2( m1, m2 );
            MIN_MAX_SSE2( m0, m1 );
            __m128i m3 = _mm_cvtsi32_si128( src[y*max_w+x-3] );
            __m128i m4 = _mm_cvtsi32_si128( src[y*max_w+x  ] );
            __m128i m5 = _mm_cvtsi32_si128( src[y*max_w+x+3] );
            __m128i ce = m4;
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m4, m5 );
            MIN_MAX_SSE2( m3, m4 );
            MIN_MAX_SSE2( m0, m3 );
            MIN_MAX_SSE2( m2, m5 );
            MIN_MAX_SSE2( m1, m4 );
            __m128i m6 = _mm_cvtsi32_si128( src[(y+1)*max_w+x-3] );
            __m128i m7 = _mm_cvtsi32_si128( src[(y+1)*max_w+x  ] );
            __m128i m8 = _mm_cvtsi32_si128( src[(y+1)*max_w+x+3] );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m7, m8 );
            MIN_MAX_SSE2( m6, m7 );
            MIN_MAX_SSE2( m3, m6 );
            MIN_MAX_SSE2( m2, m8 );
            MIN_MAX_SSE2( m4, m7 );
            MIN_MAX_SSE2( m1, m4 );
            MIN_MAX_SSE2( m2, m4 );
            MIN_MAX_SSE2( m4, m6 );
            MIN_MAX_SSE2( m2, m4 );

            __m128i diff = _mm_subs_epi16( ce, m4 ); // 
            __m128i mask = _mm_and_si128( _mm_cmplt_epi16( diff, threshold128_p ), _mm_cmpgt_epi16( diff, threshold128_m ) ); // }XN
            diff = _mm_and_si128( diff, mask ); // }XNKp
            __m128i p = _mm_subs_epi16( ce, diff ); // Kp
            p = _mm_insert_epi16( p, src[y*max_w+x+1],  1 );
            _mm_stream_si32( (int *)&dst[y*max_w+x  ], _mm_cvtsi128_si32( p ) );
            _mm_stream_si32( (int *)&dst[y*max_w+x+2], MK_INT( src[y*max_w+x+2], src[y*max_w+x+3] ) );
        }
        else
        {
            // E[Rs[
            for( ; x < w; x++ ) dst[y*max_w+x] = src[y*max_w+x];
        }
    }
}

//---------------------------------------------------------------------
// }`XbhΉo[Wp_~[֐
//---------------------------------------------------------------------
BOOL exec_mtf_dummy( MULTI_THREAD_FUNC func, void *param1, void *param2 )
{
    func( 0, 1, param1, param2 );
    return TRUE;
}

//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp, FILTER_PROC_INFO *fpip )
{
    // AviUtl̃}`Xbh֐̑I
    // Ήo[Wł exec_mtf_dummy gp
    BOOL (*exec_mtf)(MULTI_THREAD_FUNC, void*, void*)
        = fp->exfunc->exec_multi_thread_func
        ? fp->exfunc->exec_multi_thread_func
        : exec_mtf_dummy;

    const int h = fpip->h;
    const int num = fp->track[1];

    THREAD_PARAM tp;
    tp.MSE = fp->track[0];

    if( !!fp->check[0] )
    {
        // 1_ōr郂[h
        // 1passŏł̂ŃANZXȂł

        for( int cnt = 0; cnt < num; cnt++ )
        {
            exec_mtf( thread_median_diff, &tp, fpip );

            // 摜̈̃|C^ւ
            PIXEL_YC *ycp_swap = fpip->ycp_edit;
            fpip->ycp_edit = fpip->ycp_temp;
            fpip->ycp_temp = ycp_swap;
        }
    }
    else
    {
        // 5_ōr郂[h
        // 2passKviɕj

        for( int cnt = 0; cnt < num; cnt++ )
        {
            // CPULbṼqbgオ悤Ȃ̂ŕĎs
            // ͏c̃TCYɉĕύX
            int separate_num = 1;
            if( h >= 960 )      separate_num = 3;
            else if( h >= 480 ) separate_num = 2;
            for( int j = 0; j < separate_num; j++ )
            {
                tp.separate_start = (h *  j   ) / separate_num;
                tp.separate_end   = (h * (j+1)) / separate_num;
                exec_mtf( thread_median, &tp, fpip );

                tp.separate_start -= 1;
                tp.separate_end   -= 1;
                if( tp.separate_start <  1 ) tp.separate_start = 1;
                if( tp.separate_end <= tp.separate_start ) continue;
                exec_mtf( thread_diff  , &tp, fpip );
            }
        }
    }

    return TRUE;
}
